unit SQLite3_Unit;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, FireDAC.Stan.Intf, FireDAC.Stan.Option,
  FireDAC.Stan.Error, FireDAC.UI.Intf, FireDAC.Phys.Intf, FireDAC.Stan.Def,
  FireDAC.Stan.Pool, FireDAC.Stan.Async, FireDAC.Phys, FireDAC.Phys.SQLite,
  FireDAC.Phys.SQLiteDef, FireDAC.Stan.ExprFuncs, FireDAC.VCLUI.Wait,
  FireDAC.Stan.Param, FireDAC.DatS, FireDAC.DApt.Intf, FireDAC.DApt, Data.DB,
  FireDAC.Comp.DataSet, FireDAC.Comp.Client, FireDAC.Comp.UI, Vcl.StdCtrls,
  Vcl.Grids, Vcl.Buttons, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    SpeedButton_connect: TSpeedButton;
    Label_connect: TLabel;
    Edit_SQ3DBPATH: TEdit;
    Panel5: TPanel;
    StringGrid1: TStringGrid;
    Panel2: TPanel;
    SpeedButton_CsvImport: TSpeedButton;
    SpeedButton_Open: TSpeedButton;
    GroupBox2: TGroupBox;
    SpeedButton_Select: TSpeedButton;
    FDConnection1: TFDConnection;
    FDPhysSQLiteDriverLink1: TFDPhysSQLiteDriverLink;
    FDGUIxWaitCursor1: TFDGUIxWaitCursor;
    FDQuery1: TFDQuery;
    OpenDialog1: TOpenDialog;
    GroupBox1: TGroupBox;
    SpeedButton_Create: TSpeedButton;
    SpeedButton_Drop: TSpeedButton;
    Edit_Files: TEdit;
    Edit_ZIP: TEdit;
    Edit_ADDR: TEdit;
    Label_HelpMess: TLabel;
  procedure SQL_TRAN_1;
    procedure SpeedButton_connectClick(Sender: TObject);
    procedure SpeedButton_CreateClick(Sender: TObject);
    procedure SpeedButton_DropClick(Sender: TObject);
    procedure SpeedButton_SelectClick(Sender: TObject);
    procedure SpeedButton_OpenClick(Sender: TObject);
    procedure SpeedButton_CsvImportClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.SpeedButton_SelectClick(Sender: TObject);
var
  sqlstmt:string;
begin
//SELECT
 SQLstmt:='SELECT * FROM ZIP_TEMP '
  +' WHERE PS7 = :PS7';

    FDQuery1:=TFDQuery.Create(Self);
    FDQuery1.Connection:=FDConnection1;

    FDQuery1.SQL.Clear;   //SQLر
    FDQuery1.SQL.Text:= sqlstmt;  // sSQLZbg
    FDQuery1.ParamByName('PS7').AsString   := Edit_ZIP.Text;
    if (FDQuery1.Active=False) then FDQuery1.Active:=True;
    FDQuery1.Open();
    if not FDQuery1.Eof  then
    begin
      Edit_ADDR.Text:= FDQuery1.FieldByName('AD7').AsWideString;
    end
    else
    begin
      Edit_ZIP.Clear;
      Edit_ADDR.Clear;
    end;
    FDQuery1.Close;
end;

procedure TForm1.SpeedButton_CreateClick(Sender: TObject);
var
  sqlstmt:string;
begin
  sqlstmt:='CREATE TABLE '+'ZIP_TEMP '+
    ' ( '+
    'X0401      Text( 6),'+
    'OLD        Text( 5),'+
    'NEW_PS7    Text( 7),'+
    'KANA1      Text(40),'+
    'KANA2      Text(40),'+
    'KANA3      Text(40),'+
    'AD1        Text(40),'+
    'AD2        Text(40),'+
    'AD3        Text(40),'+
    'P10        Text( 1),'+
    'P11        Text( 1),'+
    'P12        Text( 1),'+
    'P13        Text( 1),'+
    'P14        Text( 1),'+
    'P15        Text( 1),'+
    'PS7        Text(8) NOT NULL,'+
    'AD7        Text(44) '+
    ')';

  if FDConnection1.Connected=true then
  begin
    try
      FDQuery1:=TFDQuery.Create(Self);
      FDQuery1.Connection:=FDConnection1;
      FDQuery1.SQL.Clear;
      FDQuery1.SQL.Add(sqlstmt);
      FDQuery1.ExecSQL();
    except
      on E: EFDDBEngineException do
      ShowMessage(E.ClassName+' error raised, with message : '+E.Message);
    end;
  end
  else ShowMessage('Connected ERR');
end;

procedure TForm1.SQL_TRAN_1;
const
  //----------------------------------------------------------------------------
  SQL_ZIP_APPEND ='insert into ZIP_TEMP'
  +' ('
  +'X0401,OLD,NEW_PS7,KANA1,KANA2,KANA3,AD1,AD2,AD3,'
  +'P10,P11,P12,P13,P14,P15,PS7,AD7'
  +') '
  +'values'
  +' ('
  +':X0401,:OLD,:NEW_PS7,:KANA1,:KANA2,:KANA3,:AD1,:AD2,:AD3,'
  +':P10,:P11,:P12,:P13,:P14,:P15,:PS7,:AD7'
  +' )';
  //----------------------------------------------------------------------------
var
  wNEW_PS7,wAD1,wAD2,wAD3,wAD7:String;
  s100,s201,s202,s203,s204,s205,s206,s207,s208,s209,s210,s211,s212,s213 :String;
  s214,s215,s216,s217,s218,s219 :String;
begin
  //-------------------------------------------TD_ID擾
  //SpeedButton_GEN_TDClick(SpeedButton_GEN_TD);
  //-------------------------------------------TD_ID擾 END

  if not FDConnection1.InTransaction then
  begin
    FDConnection1.StartTransaction;
    try
      //--------------------------------------
      try
        FDQuery1.SQL.Clear;
          FDQuery1.SQL.Text :=SQL_ZIP_APPEND;
          //SQL_Param;
          wNEW_PS7:=Trim(StringGrid1.Cells[1,2]);
          wAD1:=Trim(StringGrid1.Cells[1,6]);
          wAD2:=Trim(StringGrid1.Cells[1,7]);
          wAD3:=Trim(StringGrid1.Cells[1,8]);

          FDQuery1.ParamByName('X0401').AsString   :=Trim(StringGrid1.Cells[1,0]);
          FDQuery1.ParamByName('OLD').AsString     :=Trim(StringGrid1.Cells[1,1]);
          FDQuery1.ParamByName('NEW_PS7').AsString :=Trim(StringGrid1.Cells[1,2]);
          FDQuery1.ParamByName('KANA1').AsString   :=Trim(StringGrid1.Cells[1,3]);
          FDQuery1.ParamByName('KANA2').AsString   :=Trim(StringGrid1.Cells[1,4]);
          FDQuery1.ParamByName('KANA3').AsString   :=Trim(StringGrid1.Cells[1,5]);
          FDQuery1.ParamByName('AD1').AsString     :=Trim(StringGrid1.Cells[1,6]);
          FDQuery1.ParamByName('AD2').AsString     :=Trim(StringGrid1.Cells[1,7]);
          FDQuery1.ParamByName('AD3').AsString     :=Trim(StringGrid1.Cells[1,8]);
          FDQuery1.ParamByName('P10').AsString     :=Trim(StringGrid1.Cells[1,9]);
          FDQuery1.ParamByName('P11').AsString     :=Trim(StringGrid1.Cells[1,10]);
          FDQuery1.ParamByName('P12').AsString     :=Trim(StringGrid1.Cells[1,11]);
          FDQuery1.ParamByName('P13').AsString     :=Trim(StringGrid1.Cells[1,12]);
          FDQuery1.ParamByName('P14').AsString     :=Trim(StringGrid1.Cells[1,13]);
          FDQuery1.ParamByName('P15').AsString     :=Trim(StringGrid1.Cells[1,14]);
          FDQuery1.ParamByName('PS7').AsString     :=copy(wNEW_PS7,1,3)+'-'+copy(wNEW_PS7,4,4);



            s100 :=Trim(wAD1)+Trim(wAD2)+Trim(wAD3);
            //ߓssZk2010
            s201:=StringReplace(s100,'kCDys','Dys',[rfReplaceAll]);
            s202:=StringReplace(s201,'{錧s','s',[rfReplaceAll]);
            s203:=StringReplace(s202,'ʌ܎s','܎s',[rfReplaceAll]);
            s204:=StringReplace(s203,'tts','ts',[rfReplaceAll]);
            s205:=StringReplace(s204,'_ސ쌧ls','ls',[rfReplaceAll]);
            s206:=StringReplace(s205,'_ސ쌧s','s',[rfReplaceAll]);
            s207:=StringReplace(s206,'_ސ쌧͌s','͌s',[rfReplaceAll]);
            s208:=StringReplace(s207,'VVs','Vs',[rfReplaceAll]);
            s209:=StringReplace(s208,'ÉÉs','És',[rfReplaceAll]);
            s210:=StringReplace(s209,'Éls','ls',[rfReplaceAll]);
            s211:=StringReplace(s210,'mÉs','És',[rfReplaceAll]);
            s212:=StringReplace(s211,'s{ss','ss',[rfReplaceAll]);
            s213:=StringReplace(s212,'{s','s',[rfReplaceAll]);
            s214:=StringReplace(s213,'{s','s',[rfReplaceAll]);
            s215:=StringReplace(s214,'Ɍ_ˎs','_ˎs',[rfReplaceAll]);
            s216:=StringReplace(s215,'RRs','Rs',[rfReplaceAll]);
            s217:=StringReplace(s216,'LLs','Ls',[rfReplaceAll]);
            s218:=StringReplace(s217,'kBs','kBs',[rfReplaceAll]);
            s219:=StringReplace(s218,'s','s',[rfReplaceAll]);
            wAD7:=copy(s219,1,44);

          FDQuery1.ParamByName('AD7').AsString     :=wAD7;

          Label_HelpMess.Caption:=copy(wNEW_PS7,1,3)+'-'+copy(wNEW_PS7,4,4)+'   '+wAD7; //(wAD1)+Trim(wAD2)+Trim(wAD3);
          Label_HelpMess.Update;
          Application.ProcessMessages;

        FDQuery1.ExecSQL();
      finally
      //  //FDQuery1.Close;
      end;
      //
      FDConnection1.Commit;
      // ShowMessage('o^܂I     ');
    except
      FDConnection1.Rollback;
      ShowMessage('[[obN܂B');
    end;
  end;

//
end;
//------------------------------------------------------------------------------

procedure TForm1.SpeedButton_CsvImportClick(Sender: TObject);
var
  CSVFile: TextFile;
  st: TStringList;
  str: string;
  s1,s2:String;
  i: integer;
begin
  // eXĝ߃e[uɂ
  // CSV̓ǂݍݏ
  st := TStringList.Create;
  try
    // CSVt@CɃI[v
    // AssignFile(CSVFile, 'TEST.CSV');
    AssignFile(CSVFile,Edit_Files.Text);  //

    Reset(CSVFile);
    try
      ReadLn(CSVFile, str);          // CSV̂Psǂݍ
      while (eof(CSVFile) = false) do
      begin
        // CSV̓ǂݍ
        ReadLn(CSVFile, str);          // CSV̂Psǂݍ
        st.CommaText := str;           // 𕪊
        for i := 0 To st.Count-1 do
          StringGrid1.Cells[1,i] :=st.Strings[i];

        // R[h̒ǉ
        SQL_TRAN_1;
      end;
    finally
      CloseFile(CSVFile);
    end;
  finally
    st.Free;
  end;
end;

procedure TForm1.SpeedButton_DropClick(Sender: TObject);
var
  sqlstmt:string;
begin
  sqlstmt:='DROP TABLE ZIP_TEMP ';
  if FDConnection1.Connected=true then
  begin
    try
      FDQuery1:=TFDQuery.Create(Self);
      FDQuery1.Connection:=FDConnection1;
      FDQuery1.SQL.Clear;
      FDQuery1.SQL.Add(sqlstmt);
      FDQuery1.ExecSQL();
    except
      on E: EFDDBEngineException do
      ShowMessage(E.ClassName+' error raised, with message : '+E.Message);
    end;
  end
  else ShowMessage('Connected ERR');
end;

procedure TForm1.SpeedButton_OpenClick(Sender: TObject);
begin
  if  OpenDialog1.Execute  then
  begin
    Edit_Files.Text:=OpenDialog1.FileName;
  end;
end;

procedure TForm1.SpeedButton_connectClick(Sender: TObject);
begin
//  FDPhysSQLiteDriverLink1.VendorLib :='sqlite3.dll';
  FDConnection1.Params.Values['OpenMode'] :='CreateUTF8';  //CharSet
  FDConnection1.Params.Values['Database'] :=GetCurrentDir+'\'+Edit_SQ3DBPATH.Text;

  FDConnection1.Connected:=true;
  if FDConnection1.Connected=True  then
  begin
    Edit_SQ3DBPATH.Visible:=False;
    Label_connect.Caption:='connect success';
  end
  else
  begin
    Edit_SQ3DBPATH.Text:='Retype' ;
  end;

end;

end.
